<?php

/*
w3btorrent (keep it simple) - simple web fronted torrent client
Copyright (C) 2005, 2007  Vegard Hammerseth <thewulong@gmail.com> (http://thewulong.com)

This file is part of w3btorrent.

w3btorrent is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
any later version.
*/



class downloads
{
	function compress_archive($arg_path,$arg_type)
	{
		if (is_file($arg_path) || !is_readable($arg_path) || is_file($arg_path.".".$arg_type) || empty($_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['nohup']) || empty($_SESSION[$_SERVER['REMOTE_ADDR']]['bin'][$arg_type]))
		{
			return;
		}

		if ($arg_type == "tar")
		{
			downloads::tar_archive($arg_path);
		}
		elseif ($arg_type == "gzip")
		{
			/* we need `tar` to use gzip */
			if (is_file($arg_path.".tar.".$arg_type) || empty($_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['tar']))
			{
				return;
			}
			downloads::gzip_archive($arg_path);	
		}
		elseif ($arg_type == "bzip2")
		{
			/* we need `tar` to use bzip2 */
			if (is_file($arg_path.".tar.".$arg_type) || empty($_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['tar']))
			{
				return;
			}
			downloads::bzip2_archive($arg_path);
		}
		elseif ($arg_type == "rar")
		{
			downloads::rar_archive($arg_path);
		}
		elseif ($arg_type == "zip")
		{
			downloads::zip_archive($arg_path);
		}
	}
	
	
	/* create archive with tar */
	function tar_archive($arg_path)
	{
		$file 	= escapeshellarg(basename($arg_path));
		$logfile = escapeshellarg(realpath($_SESSION[$_SERVER['REMOTE_ADDR']]['sysdir']."/.htlog"));
		$oldwd	= getcwd();
		chdir(dirname($arg_path));
		etc::safe_exec($_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['nohup']." ".$_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['tar']." -cf $file.tar $file >> $logfile &");
		chdir($oldwd);
		w3btorrent::write2log("'".basename($arg_path).".tar' archive created with `tar`.");
	}


	/* create archive with tar and gzip */
	function gzip_archive($arg_path)
	{
		$file 	= escapeshellarg(basename($arg_path));
		$logfile = escapeshellarg(realpath($_SESSION[$_SERVER['REMOTE_ADDR']]['sysdir']."/.htlog"));
		$oldwd	= getcwd();
		chdir(dirname($arg_path));
		etc::safe_exec($_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['nohup']." ".$_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['tar']." -zcf $file.tar.gz $file >> $logfile &");
		chdir($oldwd);
		w3btorrent::write2log("'".basename($arg_path).".tar.gz' archive created with `gzip`.");
	}

	
	/* create archive with tar and bzip2 */
	function bzip2_archive($arg_path)
	{
		$file 	= escapeshellarg(basename($arg_path));
		$oldwd	= getcwd();
		chdir(dirname($arg_path));
		etc::safe_exec($_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['nohup']." ".$_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['tar']." -cf - $file | ".$_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['bzip2']." > $file.tar.bz2 &");
		chdir($oldwd);
		w3btorrent::write2log("'".basename($arg_path).".tar.bz2' archive created with `bzip2`.");
	}


	/* create archive with rar */
	function rar_archive($arg_path)
	{
		$file 	= escapeshellarg(basename($arg_path));
		$logfile = escapeshellarg(realpath($_SESSION[$_SERVER['REMOTE_ADDR']]['sysdir']."/.htlog"));
		$oldwd	= getcwd();
		chdir(dirname($arg_path));
		etc::safe_exec($_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['nohup']." ".$_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['rar']." a -r $file.rar $file >> $logfile &");
		chdir($oldwd);
		w3btorrent::write2log("'".basename($arg_path).".rar' archive created with `rar`.");
	}
	
	
	/* create a archive with zip */
	function zip_archive($arg_path)
	{
		$file 	= escapeshellarg(basename($arg_path));
		$oldwd	= getcwd();
		chdir(dirname($arg_path));
		etc::safe_exec($_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['nohup']." ".$_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['zip']." -r - $file > $file.zip &");
		chdir($oldwd);
		w3btorrent::write2log("'".basename($arg_path).".zip' archive created with `zip`.");
	}

	function decompress_archive($arg_path,$arg_type)
	{
		if (!is_file($arg_path) || !is_readable($arg_path) || empty($_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['nohup']) || empty($_SESSION[$_SERVER['REMOTE_ADDR']]['bin'][$arg_type]))
		{
			return;
		}

		if ($arg_type == "tar")
		{
			downloads::untar_archive($arg_path);
		}
		elseif ($arg_type == "rar")
		{
			downloads::unrar_archive($arg_path);
		}
		elseif ($arg_type == "gzip")
		{
			downloads::gzip_archive($arg_path);
		}
		elseif ($arg_type == "bzip2")
		{
			downloads::bzip2_archive($arg_path);
		}
		elseif ($arg_type == "zip")
		{
			downloads::unzip_archive($arg_path);
		}
	}


	/* untar */
	function untar_archive($arg_path)
	{
		$file		 = escapeshellarg($arg_path);
		$save_dir = etc::remove_ext($arg_path)."/";
		if (!is_dir($save_dir))
		{
			mkdir($save_dir);
		}
		$save_dir = escapeshellarg($save_dir);
		
		etc::safe_exec($_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['nohup']." ".$_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['tar']." -xf $file -C $save_dir >> ".escapeshellarg(realpath($_SESSION[$_SERVER['REMOTE_ADDR']]['sysdir']."/.htlog"))." &");
		w3btorrent::write2log("Exctracting $file to $save_dir with `tar`.");
	}


	/* unrar */
	function unrar_archive($arg_path)
	{
		$file		 = escapeshellarg($arg_path);
		$save_dir = escapeshellarg(etc::remove_ext($arg_path)."/");
		
		etc::safe_exec($_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['nohup']." ".$_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['rar']." e $file $save_dir >> ".escapeshellarg(realpath($_SESSION[$_SERVER['REMOTE_ADDR']]['sysdir']."/.htlog"))." &");
		w3btorrent::write2log("Exctracting $file to $save_dir with `unrar`.");
	}
	
	
	/* unzip */
	function unzip_archive($arg_path)
	{
		$file		 = escapeshellarg($arg_path);
		$save_dir = escapeshellarg(etc::remove_ext($arg_path)."/");
		
		etc::safe_exec($_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['nohup']." ".$_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['unzip']." $file -d $save_dir >> ".escapeshellarg(realpath($_SESSION[$_SERVER['REMOTE_ADDR']]['sysdir']."/.htlog"))." &");
		w3btorrent::write2log("Exctracting $file to $save_dir with `unzip`.");
	}

	
	/* download file, supporting thorugh webtree and not */
	function download($arg_path)
	{
		if (!is_file($arg_path) || !is_readable($arg_path))
		{
			return;
		}
		
		w3btorrent::write2log("'$arg_path' downloaded.");
		
		/* file is in our tree */
		if (etc::in_webtree($arg_path))
		{
			$location = substr($arg_path,strlen(dirname($_SERVER['SCRIPT_FILENAME']))+1);
			$location = str_replace("%2F","/",urlencode($location));
			header("location: $location");
			exit();
		}
		
		/* let's be able to continue browsing:) */
		session_write_close();
		
		/* file is not in our web tree and need to download it through PHP */
		if (!$type = mime_content_type($arg_path))
		{
			$type = "application/octet-stream";
		}
		
		/* make sure we don't timeout */
		ini_set("max_execution_time",7200); // 48 hours
		header("content-type: ".$type);
		header("content-disposition: attachment; filename=\"".urldecode(basename($arg_path))."\";");
		header("content-length: ".filesize($arg_path));
		
		/* let's be smart printing out chunks */
		$fd = fopen($arg_path,"r");
		while (!feof($fd))
		{
			echo fread($fd,4096);
			flush();
		}
		fclose($fd);
		exit();
	}
	
	
	/* encode a video file into MPEG, DVD format */
	function tovid_file($arg_path)
	{
		if (!is_file($arg_path) || !is_readable($arg_path) || empty($_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['nohup']) || empty($_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['tovid']))
		{
			return;
		}
		$file		 = escapeshellarg($arg_path);
		$outfile	 = escapeshellarg(etc::remove_ext($arg_path));
		
		etc::safe_exec($_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['nohup']." ".$_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['tovid']." -in $file -out $outfile >> ".escapeshellarg(realpath($_SESSION[$_SERVER['REMOTE_ADDR']]['sysdir']."/.htlog"))." &");
		w3btorrent::write2log("Creating '".basename(etc::remove_ext($arg_path)).".mpg' with `tovid`.");
	}
	
	
	/* convert bin/cue into iso format */
	function bchunk_file($arg_bin_path,$arg_cue_path)
	{
		if (!is_file($arg_bin_path) || !is_file($arg_cue_path) || !is_readable($arg_bin_path) || !is_readable($arg_cue_path) || empty($_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['nohup']) || empty($_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['bchunk']))
		{
			return;
		}
		$bin		= escapeshellarg($arg_bin_path);
		$cue		= escapeshellarg($arg_cue_path);
		$outfile = escapeshellarg(etc::remove_ext($arg_bin_path).".iso");
		
		etc::safe_exec($_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['nohup']." ".$_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['bchunk']." $bin $cue $outfile >> ".escapeshellarg(realpath($_SESSION[$_SERVER['REMOTE_ADDR']]['sysdir']."/.htlog"))." &");
		w3btorrent::write2log("Creating $outfile with `bchunk`.");
	}
}

?>