<?php

/*
PHP class to get all dir/file's in a directory with info about the file/dir's
Copyright (C) 2006, 2007  Vegard Hammerseth <thewulong@gmail.com> (http://thewulong.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
*/



class hdc // handle directory contents
{



	/* get all directorys in a directory */
	function list_dirs($arg_dir)
	{
		$dirs = array();
		if (!is_dir($arg_dir) || !$dopen = opendir($arg_dir))
		{
			return;
		}
		
		while ($f = readdir($dopen))
		{
			if ($f == "." || $f == ".." || !is_dir($arg_dir."/$f"))
			{
				continue;
			}
			$dirs[] = $f;
		}
		fclose($dopen);
		
		return $dirs;
	}



	/* get real dir size, including all files */
	function real_dir_size($_dir)
	{
		$size = 0;
		foreach (glob($arg_dir."/*") as $file)
		{
			
			if (is_dir($file))
			{
				$size += hdc::real_dir_size($file);
			}
			else
			{
				$size += filesize($file);
			}
		}

		return $size;
	}


	
	/* get all files in a directory */
	function list_files($arg_dir)
	{
		$files = array();
		if (!is_dir($arg_dir) || !$dopen = opendir($arg_dir))
		{
			return;
		}
		
		while ($f = readdir($dopen))
		{
			if ($f == "." || $f == ".." || !is_file($arg_dir."/$f"))
			{
				continue;
			}
			$files[] = $f;
		}
		fclose($dopen);
		
		return $files;
	}
}

?>
