<?php

/*
w3btorrent (keep it simple) - simple web fronted torrent client
Copyright (C) 2005, 2007  Vegard Hammerseth <thewulong@gmail.com> (http://thewulong.com)

This file is part of w3btorrent.

w3btorrent is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
any later version.
*/



class w3btorrent
{

	/* version */
	function version()
	{
		return "w3btorrent 0.1.3 beta";
	}

	var $div = "dark";
	function div_color()
	{
		if (empty($this->div))
		{
			$this->div = "dark";
		}
		else
		{
			$this->div = "";
		}
		return $this->div;
	}	
	
	
	
	/* if w3btorrent needs to be setup */
	function setup($xml)
	{
		/* we dont't got a valid system directory */
		if (!w3btorrent::valid_ddir($xml->index['CONFIGURATION']['SYSTEM']['PATH']['DIR']['value']))
		{
			return true;
		}
		
		/* got default password */
		if ($xml->index['CONFIGURATION']['ACCOUNT']['ADMIN']['PASSWORD']['value'] == "700c8b805a3e2a265b01c77614cd8b21")
		{
			return true;
		}
		
		/* we don't have nohup */
		if (empty($_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['nohup']))
		{
			return true;
		}
		
		/* we don't have a working core */
		if (empty($_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['wctorrent']) && empty($_SESSION[$_SERVER['REMOTE_ADDR']]['bin']['bt2status']))
		{
			return true;
		}
	}


	/* is our system directory valid */
	function valid_ddir($arg_dir)
	{
		if (is_dir($arg_dir) && is_readable($arg_dir) && is_writeable($arg_dir) && is_executable($arg_dir))
		{
			return true;
		}
   }
	
	
	
	/* set binary paths in our session, so we don't need to check them all the time */
	function set_session_settings($xml)
	{
		/* remove last settings */
		if (isset($_SESSION[$_SERVER['REMOTE_ADDR']]))
		{
			unset($_SESSION[$_SERVER['REMOTE_ADDR']]['setup'],$_SESSION[$_SERVER['REMOTE_ADDR']]['ddir'],$_SESSION[$_SERVER['REMOTE_ADDR']]['bin']);
		}
		
		/* set user and password in session, for RSS */
		$_SESSION[$_SERVER['REMOTE_ADDR']]['user']		= $xml->index['CONFIGURATION']['ACCOUNT']['ADMIN']['USERNAME']['value'];
		$_SESSION[$_SERVER['REMOTE_ADDR']]['password'] 	= $xml->index['CONFIGURATION']['ACCOUNT']['ADMIN']['PASSWORD']['value'];		
		
		/* ddir */
		$ddir = $xml->index['CONFIGURATION']['SYSTEM']['PATH']['DIR']['value'];
		if (w3btorrent::valid_ddir($ddir))
		{
			$_SESSION[$_SERVER['REMOTE_ADDR']]['ddir'] = realpath($ddir);
		}
		
		/* programs */
		foreach ($xml->index['CONFIGURATION']['SYSTEM']['PATH']['BIN'] as $key=>$bin)
		{
			$key = strtolower($key);
			$bin = $bin['value'];
			
			/* we need to have entire bittorrent env. to use `bt2status` core */
			if ($key == "bt2status" && !etc::exec_path("btdownloadcurses"))
			{
				continue;
			}
			
			/* let's see if we can find this path */
			if (empty($bin))
			{
				$bin = etc::exec_path($key);
			}
			
			/* is it a valid binary file? */
			if (is_file($bin) && is_executable($bin))
			{
				$_SESSION[$_SERVER['REMOTE_ADDR']]['bin'][$key] = escapeshellcmd(realpath($bin));
			}
		}
		
		/* setup */
		if (w3btorrent::setup($xml))
		{
			$_SESSION[$_SERVER['REMOTE_ADDR']]['setup'] = 1;
		}
		
	}
	
	
	
	/* return a HTML progress bar */
	function progress_bar_html($arg_percent,$arg_width = 100)
	{
		if (!is_numeric($arg_percent) || !is_numeric($arg_width))
		{
			return;
		}
		
		$percent = ($arg_percent < 100?$arg_percent:100);
		$width	= ($percent*$arg_width)/100;
		
		$green	= round($width,0);
		$dark		= round($arg_width-$green,0);
		
		/* start */
		$return  = "<img src=\"pix/".($percent > 0?"bar_left.png":"bar_dark_left.png")."\" alt=\"\"/>";	
		/* middle */
		$return .= "<img style=\"width:${green}px;\" src=\"pix/bar_middle.png\" alt=\"\"/>";
		$return .= "<img style=\"width:${dark}px;\" src=\"pix/bar_dark_middle.png\" alt=\"\"/>";
		/* end */
		/* tmp fix */
		if (strpos($_SERVER['HTTP_USER_AGENT'],"opera") !== false)
		{
			$return .= "<img style=\"float:right;\" src=\"pix/".($percent > 99?"bar_right.png":"bar_dark_right.png")."\" alt=\"\"/>";
		}
		else
		{
			$return .= "<img src=\"pix/".($percent > 99?"bar_right.png":"bar_dark_right.png")."\" alt=\"\"/>";
		}
		/* percent */
		$return .= "<span class=\"percent\">${percent}%</span>";
		
		return $return;
	}


	
	/* function to keep track on every action */
	function write2log($arg_string)
	{
		if (!$fd = fopen($_SESSION[$_SERVER['REMOTE_ADDR']]['sysdir']."/.htlog","a+"))
		{
			return;
		}
		
		if (!fwrite($fd,"(".date("Y-m-d H:i").") (".$_SERVER['REMOTE_ADDR'].") $arg_string\n"))
		{
			return;
		}
		fclose($fd);
	}
}

?>
