<?php

/*
PHP class to parse xml file and create an array for easyier usage,
it also parases an array to xml and let's you write back to any file.
Copyright (C) 2006, 2007  Vegard Hammerseth <thewulong@gmail.com> (http://thewulong.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
*/



class xml
{
	var $parse  = array();
	var $index 	= array();



	/* init */
	function load($arg_config_path)
	{
		/* file don't exists */
		if (!is_file($arg_config_path))
		{
			//echo "NO SUCH FILE '$arg_config_path'\n";
			return;
		}

		/* if file is not readable */
		if (!is_readable($arg_config_path))
		{
			//echo "UNABLE TO READ FILE '$arg_config_path'\n";
			return;
		}

		/* parse the XML data if we haven't done it before */
		if (sizeof($this->parse) == 0 && !$this->parse = $this->parse($arg_config_path))
		{
			//echo "UNABLE TO PARSE '$arg_config_path'\n";
			return;
		}

		/* create a simpler index of parsed XML data, if we haven't done it before */
		if (sizeof($this->index) == 0 && !$this->index = $this->create_index($this->parse))
		{
			return;
		}
	}



	/* create a simple index for easier getting data */
	function create_index($arg_parse)
	{
		if (!is_array($arg_parse))
		{
			return;
		}

		$eval_index		   = array();
		$eval_array		   = "";
		$create_array		= "\$eval_index";
		$create_subarray	= "";

		foreach ($arg_parse as $e)
		{
			/* create sub-arrays */
			$tag = "['".$e['tag']."']";
			switch ($e['type'])
			{
				case "open":
					$create_array 	 .= $tag;
					$create_subarray2 = $create_array;
					break;
				case "complete":
					$create_subarray .= $create_array.$tag."['value'] = \"".(isset($e['value'])?$e['value']:"")."\";";
					$create_subarray2 = $create_array.$tag;
					break;
				case "close":
					$create_array     = substr($create_array,0,"-".strlen($tag));

			}

			/* add our attributes in lower case so we don't crash with the tags */
			if (isset($e['attributes']) && is_array($e['attributes']))
			{
				foreach ($e['attributes'] as $index=>$value)
				{
					$create_subarray .= $create_subarray2."['".strtolower($index)."'] = \"".$value."\";";
				}
			}
		
			/* collect them all in one array */
			if (isset($create_subarray))
			{
				$eval_array .= $create_subarray;
				$create_subarray = "";
			}
		}

		/* here we create a $index variable with all the data we'd want */
		eval($eval_array);

		return $eval_index;
	}



	/* parse the data for easier use */
	function parse($arg_config_path)
	{
		/* can we read the file? */
		if (!is_readable($arg_config_path))
		{
			return;
		}

		$xml_parse = xml_parser_create();
		if (!xml_parse_into_struct($xml_parse,file_get_contents($arg_config_path),$parse))
		{
			return;
		}
		
		/* free some memory */
		xml_parser_free($xml_parse);

		return $parse;
	}



	/* get the <?xml ?> top of a file, if any */
	function get_xml_tag($arg_file)
	{
		if (!is_readable($arg_file) || !$fsock = fopen($arg_file,"r"))
		{
			return;
		}
		
		$fdata = fread($fsock,256);
		preg_match("/(<\?xml([^>]*)?>)/mis",$fdata,$return);

		if (isset($return['1']))
		{
			return $return['1'];
		}
	}



	/* write configuration to a file */
	function write_config($arg_array,$arg_file)
	{
		if (!is_array($arg_array) || !is_file($arg_file) || !is_writable($arg_file))
		{
			return;
		}

		$xmldata  = xml::get_xml_tag($arg_file);
		$xmldata .= "\n".xml::array2xml($arg_array);

		if (!$fsock = fopen($arg_file,"w"))
		{
			return;
		}

		/* we don't use file_put_contents() for supporting PHP4 users, pity them */
		if (fwrite($fsock,$xmldata))
		{
			fclose($fsock);
			return true;
		}
		fclose($fsock);
	}


	
	/* turn our indexed config array back into XML data again with this 'ugly' function */
	function array2xml($arg_array,$arg_tabs = "-1")
	{
		$return = $attrs = "";
		if (!is_array($arg_array))
		{
			return;
		}

		foreach ($arg_array as $index=>$value)
		{
			if (preg_match("/[a-z]/",$index))
			{
				continue;
			}
			/* let's add tabs for better look */
			$arg_tabs++;
			$return .= str_repeat("\t",$arg_tabs);

			$return .= "<$index".xml::get_attributes($value).">";

			if (is_array($value) && !array_key_exists("value",$value))
			{
				$return .= "\n".xml::array2xml($value,$arg_tabs).str_repeat("\t",$arg_tabs);
			}
			else
			{
				$return .= $value['value'];
			}
			$return .= "</$index>\n";
			$arg_tabs--;
		}

		return $return;
	}



	/* temporary function for handling this, get XML arguments from a array */
	function get_attributes($arg_array)
	{
		if (!is_array($arg_array))
		{
			return;
		}

		$return = "";
		foreach ($arg_array as $index=>$value)
		{
			if (!is_array($value) && $index != "value")
			{
				$return .= " $index=\"$value\"";
			}
		}

		return $return;
	}
}

?>
