<?php

/*
w3btorrent (keep it simple) - simple web fronted torrent client
Copyright (C) 2005, 2007  Vegard Hammerseth <thewulong@gmail.com> (http://thewulong.com)

This file is part of w3btorrent.

w3btorrent is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
any later version.
*/

if (!isset($_SESSION[$_SERVER['REMOTE_ADDR']]['admin']))
{
	header("location: ../../../../");
	exit();
}
require_once("inc/class/xml.class.php");
$xml = new xml;
$xml->load($_SESSION[$_SERVER['REMOTE_ADDR']]['sysdir']."/.htconfig.xml");

class ddir
{
	function are_set()
	{
		if (isset($_POST['system_path'],$_POST['submit_ddir']))
		{
			$_POST['system_path'] = stripslashes($_POST['system_path']);
			$_POST['system_path'] = str_replace("//","/",$_POST['system_path']);
			return true;
		}
	}
	
}
/* 1. change system dir */
if (ddir::are_set())
{
	if (!w3btorrent::valid_ddir($_POST['system_path']))
	{
		$status['ddir'] = "Error: Invalid directory; must be a read/write-able directory.";
	}
	else
	{
		$xml->index['CONFIGURATION']['SYSTEM']['PATH']['DIR']['value'] = $_POST['system_path'];
		w3btorrent::write2log("Changed system directory to '".$_POST['system_path']."'.");
		$status['ddir'] = "System directory successfully updated.";
		$update_config 	= 1;
	}
}
elseif (empty($_SESSION[$_SERVER['REMOTE_ADDR']]['ddir']))
{
	$status['ddir'] = "Error: You must spesify a read/write-able system directory, were download files will be stored.";
}
elseif (etc::in_webtree($xml->index['CONFIGURATION']['SYSTEM']['PATH']['DIR']['value']))
{
	$status['ddir'] =  "Warning: current download dir is in the web tree, this means that any one can access your downloaded files.";
}


/* 2. change account */
class account
{
	function are_set()
	{
		if (isset($_POST['submit_account'],$_POST['username'],$_POST['password1'],$_POST['password2']))
		{
			$_POST['username']  = stripslashes($_POST['username']);
			$_POST['password1'] = stripslashes($_POST['password1']);
			$_POST['password2'] = stripslashes($_POST['password2']);
			return true;
		}
	}
	
	
	function valid_settings()
	{
		if (empty($_POST['username']) || $_POST['password1'] == "" || $_POST['password2'] == "")
		{
			return "Invalid settings.";
		}
		elseif ($_POST['password1'] != $_POST['password2'])
		{
			return "Error: Account passwords mismatch, type 2 equal passwords.";
		}
		elseif ($_POST['password1'] == "1234")
		{
			return "Error: default password given.";
		}
	}
}
if (account::are_set())
{
	if (!$status['account'] = account::valid_settings())
	{
		if ($xml->index['CONFIGURATION']['ACCOUNT']['ADMIN']['USERNAME']['value'] != $_POST['username'])
		{
			$xml->index['CONFIGURATION']['ACCOUNT']['ADMIN']['USERNAME']['value'] = $_POST['username'];
			w3btorrent::write2log("Username changed to '".$_POST['username']."'.");
			$status['account'] = "Account settings changed.";
			$update_config = 1;
		}
		if ($xml->index['CONFIGURATION']['ACCOUNT']['ADMIN']['PASSWORD']['value'] != md5(sha1($_POST['password1'])))
		{
			$xml->index['CONFIGURATION']['ACCOUNT']['ADMIN']['PASSWORD']['value'] = md5(sha1($_POST['password1']));
			w3btorrent::write2log("Password changed.");
			$status['account'] = "Account settings changed.";
			$update_config = 1;
		}
	}
}
elseif ($xml->index['CONFIGURATION']['ACCOUNT']['ADMIN']['PASSWORD']['value'] == "700c8b805a3e2a265b01c77614cd8b21")
{
	$status['account'] = "Error: Because of security reasons; you must change password.";
}



class advanced
{
	var $bins = array(
							"wctorrent",
							"bt2status",
							"nohup",
							"wget",
							"tar",
							"gzip",
							"bzip2",
							"rar",
							"zip",
							"unzip",
							"tovid",
							"bchunk"
							);
							
	function are_set()
	{
		if (!isset($_POST['submit_advanced']))
		{
			return;
		}
		foreach ($this->bins as $bin)
		{
			if (!isset($_POST[$bin."_path"]))
			{
				return;
			}
			$_POST[$bin."_path"] = stripslashes($_POST[$bin."_path"]);
		}
		return true;
	}
}
$advanced = new advanced;
if ($advanced->are_set())
{
	foreach ($advanced->bins as $bin)
	{
		$xml->index['CONFIGURATION']['SYSTEM']['PATH']['BIN'][strtoupper($bin)]['value'] = $_POST[$bin."_path"];
	}
	$update_config = 1;
}

/* write potential changes to config */
if (isset($update_config))
{
	if (xml::write_config($xml->index,$_SESSION[$_SERVER['REMOTE_ADDR']]['sysdir']."/.htconfig.xml"))
	{
		w3btorrent::set_session_settings($xml);
	}
}

?>