<?php

/*
w3btorrent (keep it simple) - simple web fronted torrent client
Copyright (C) 2005, 2007  Vegard Hammerseth <thewulong@gmail.com> (http://thewulong.com)

This file is part of w3btorrent.

w3btorrent is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
any later version.
*/

if (!isset($_SESSION[$_SERVER['REMOTE_ADDR']]['admin']))
{
	header("location: ../../../../");
	exit();
}

require_once("inc/class/torrent.class.php");

/* we got something to do! */
if (isset($_GET['file']))
{
	$torrentfile = realpath($_SESSION[$_SERVER['REMOTE_ADDR']]['ddir']."/".base64_decode($_GET['file']));
}

if (isset($_GET['action'],$torrentfile) && substr($torrentfile,-8) == ".torrent" && file_exists($torrentfile) && in_array($_GET['action'],array("stop","start","quickstart","delete")))
{
	require_once("inc/class/xml.class.php");
	$xml = new xml;
	$xml->load($_SESSION[$_SERVER['REMOTE_ADDR']]['sysdir']."/.htconfig.xml");
	
	/* stop */
	if ($_GET['action'] == "stop")
	{
		torrent::stop_by_torrentfile($torrentfile);
	}
	/* delete */
	elseif ($_GET['action'] == "delete")
	{
		torrent::delete_by_torrentfile($torrentfile);
	}
	/* start */
	elseif ($_GET['action'] == "start" && isset($_POST['max_download_rate'],$_POST['max_upload_rate'],$_POST['min_peers'],$_POST['max_peers'],$_POST['min_uploads'],$_POST['max_uploads'],$_POST['min_port'],$_POST['max_port'],$_POST['seed'],$_POST['seed_time'],$_POST['core'],$_POST['submit_settings']))
	{
		/* valid settings? */
      if (is_numeric($_POST['max_download_rate'].$_POST['max_upload_rate'].$_POST['min_peers'].$_POST['max_peers'].$_POST['min_uploads'].$_POST['max_uploads'].$_POST['min_port'].$_POST['max_port'].$_POST['seed_time']) && $_POST['min_peers'] > 0 && $_POST['max_peers'] > 0 && $_POST['min_uploads'] > 0 && $_POST['max_uploads'] > 0 && $_POST['min_port'] > 0 && $_POST['max_port'] > 0 && $_POST['min_peers'] <= $_POST['max_peers'] && $_POST['min_uploads'] <= $_POST['max_uploads'] && $_POST['min_port'] <= $_POST['max_port'] && ($_POST['seed'] === "0" || $_POST['seed'] == 1 || $_POST['seed'] == 2) && ($_POST['core'] == "wctorrent" || $_POST['core'] == "bt2status"))
		{
			$xml->index['CONFIGURATION']['SETTINGS']['MAX_DOWNLOAD_RATE']['value'] 	= $_POST['max_download_rate'];
			$xml->index['CONFIGURATION']['SETTINGS']['MAX_UPLOAD_RATE']['value']   	= $_POST['max_upload_rate'];
			$xml->index['CONFIGURATION']['SETTINGS']['MIN_PEERS']['value']         	= $_POST['min_peers'];
			$xml->index['CONFIGURATION']['SETTINGS']['MAX_PEERS']['value']         	= $_POST['max_peers'];
			$xml->index['CONFIGURATION']['SETTINGS']['MIN_UPLOADS']['value']			= $_POST['min_uploads'];
			$xml->index['CONFIGURATION']['SETTINGS']['MAX_UPLOADS']['value']			= $_POST['max_uploads'];
			$xml->index['CONFIGURATION']['SETTINGS']['MIN_PORT']['value']				= $_POST['min_port'];
			$xml->index['CONFIGURATION']['SETTINGS']['MAX_PORT']['value']				= $_POST['max_port'];
			$xml->index['CONFIGURATION']['SETTINGS']['SUPER_SEEDER']['value']			= (empty($_POST['super_seeder'])?0:1);
			$xml->index['CONFIGURATION']['SETTINGS']['SEED_TIME']['value']				= $_POST['seed_time'];
			$xml->index['CONFIGURATION']['SETTINGS']['SEED']['value']					= $_POST['seed'];
			$xml->index['CONFIGURATION']['SETTINGS']['LAST_USED']['value']				= $_POST['core'];
			$start = 1;

			/* write changes */
			$xml->write_config($xml->index,$_SESSION[$_SERVER['REMOTE_ADDR']]['sysdir']."/.htconfig.xml");
		}
		elseif ($_POST['min_peers'] > $_POST['max_peers'])
		{
			$status = "Invalid settings. Min. peers can't be higher than max. peers.";
		}
		elseif ($_POST['min_uploads'] > $_POST['max_uploads'])
		{
			$status = "Invalid settings. Min. uploads can't be higher than max. uploads.";
		}
		elseif ($_POST['min_port'] > $_POST['max_port'])
		{
			$status = "Invalid settings. Min. port can't be higher than max. port.";
		}
		else
		{
			$status = "Invalid settings. Some values must be numeric and can't contain values beneth '1'.";
		}
	}

	
	/* start it! */
	if (isset($start) || $_GET['action'] == "quickstart")
	{
		$savedir 	= etc::remove_ext($torrentfile,"torrent");
		$s 			= $xml->index['CONFIGURATION']['SETTINGS'];
		if ($s['SEED']['value'] == 2)
		{
			$seed_time = 0;
		}
		elseif ($s['SEED']['value'] == 1)
		{
			$seed_time = $s['SEED_TIME']['value'];
		}
		else
		{
			$seed_time = "";
		} 
		/* start with wctorrent */
		if ($s['LAST_USED']['value'] == "wctorrent")
		{
			torrent::start_wctorrent_by_torrentfile($torrentfile,$s['MAX_DOWNLOAD_RATE']['value'],$s['MAX_UPLOAD_RATE']['value'],$s['MIN_PEERS']['value'],$s['MAX_PEERS']['value'],$s['MAX_PORT']['value'],$savedir,$seed_time);
		}
		elseif ($s['LAST_USED']['value'] == "bt2status")
		{
			torrent::start_bt2status_by_torrentfile($torrentfile,$s['MAX_DOWNLOAD_RATE']['value'],$s['MAX_UPLOAD_RATE']['value'],$s['MIN_PEERS']['value'],$s['MIN_PORT']['value'],$s['MAX_PORT']['value'],$s['MIN_UPLOADS']['value'],$s['MAX_UPLOADS']['value'],$s['SUPER_SEEDER']['value'],$savedir,$seed_time);
		}
		sleep(1);
	}

	if (!isset($_SERVER['AJAX']) && ($_GET['action'] != "start" || ($_GET['action'] == "start" && isset($start))))
	{
		header("location: ./");
		exit();
	}
}
/* stop all torrents */
elseif (isset($_GET['action']) && $_GET['action'] == "stop_all")
{
	require_once("inc/class/hdc.class.php");
	torrent::stop_all_by_dir(realpath($_SESSION[$_SERVER['REMOTE_ADDR']]['ddir']));
	if (!isset($_SERVER['AJAX']))
	{
		header("location: ./");
		exit();
	}
}

?>