<?php

/*
w3btorrent (keep it simple) - simple web fronted torrent client
Copyright (C) 2005, 2007  Vegard Hammerseth <thewulong@gmail.com> (http://thewulong.com)

This file is part of w3btorrent.

w3btorrent is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
any later version.
*/

/* client haven't login */
if (!isset($_SESSION[$_SERVER['REMOTE_ADDR']]['admin']))
{
	header("location: ../../../../");
	exit();
}
require_once("inc/class/hdc.class.php");

?>
<span id="torrent"></span>
<div class="top t1"><img src="pix/torrent.png" alt=""/> Torrent</div>
<div class="top t2" style="text-align:center;"><img src="pix/hdd.png" alt=""/> Size</div>
<div class="top t3"><img src="pix/down.png" alt=""/>down/<img src="pix/up.png" alt=""/>up</div>
<div class="top t4"><img src="pix/percent.png" alt=""/> Progress</div>
<div class="top t5"><img src="pix/clock.png" alt=""/> Status</div>
<div class="top t6" style="text-align:center;"><img src="pix/misc.png" alt=""/> Action</div>
<?php

$led = array(
					"pix/ledgrey.png",
					"pix/ledred.png",
					"pix/ledyellow.png",
					"pix/ledblue.png",
					"pix/ledgreen.png"
				);

$total = array(
					"files"			=>0,
					"current_size"		=>0,
					"torrent_size"		=>0,
					"down"			=>0,
					"up"			=>0,
					"percent"		=>0,
					"status"		=>0
					);
					
$w3btorrent = new w3btorrent;
foreach (hdc::list_files($_SESSION[$_SERVER['REMOTE_ADDR']]['ddir']) as $filename)
{
	$file = $_SESSION[$_SERVER['REMOTE_ADDR']]['ddir']."/$filename";
	if (substr($filename,-8) != ".torrent" || !is_file($file))
	{
		continue;
	}

	$name			= etc::remove_ext(urldecode($filename),"torrent");
	$outname		= htmlentities(etc::subword($name,25));
	$name			= htmlentities($name);
	$href 		= base64_encode($filename);
	$class  		= $w3btorrent->div_color();
	
	/* we can't read this file, print it and link to how we can fix it */
	if (!is_readable($file))
	{
		echo "<div class=\"t1 $class\"><a href=\"http://w3btorrent.sourceforge.net/?page=help&amp;search=lights\"><img src=\"".$led[0]."\" alt=\"0\"/></a> <a href=\"?page=help&amp;page2=torrent\" onclick=\"page('?page=help&amp;page2=torrent');return false;\">$outname</a></div>";
		echo "<div class=\"$class\" style=\"float:right;\"><a href=\"?page=torrent&amp;file=$href&amp;action=delete\" onclick=\"if (confirm('Are you sure you want to delete \'$name\'?')) { page('?page=torrent&amp;file=$href&amp;action=delete'); } return false;\" title=\"Delete torrent\"><img src=\"pix/delete.png\" alt=\"D\"/></a></div>";
		continue;
	}
	
	$statusfile	= $file.".status";
	if (!file_exists($statusfile))
	{
		if (!torrent::new_status_file_by_torrentfile($file))
		{
			continue;
		}
	}
	$status = torrent::status($statusfile);
	
	$size		= explode(" ",etc::byte_change($status['torrent_size'],1));
	$torrent_size	= $size['0'];
	$current_size	= etc::byte_change($status['current_size'],2,$size['1']);

?>
 	<div class="t1 <?php echo $class; ?>"><a href="http://w3btorrent.sourceforge.net/?page=help&amp;search=lights"><img src="<?php echo $led[$status['led']]; ?>" alt="<?php echo $status['led']; ?>"/></a> <a href="?page=torrent&amp;file=<?php echo $href; ?>&amp;action=info" onclick="page('?page=torrent&amp;file=<?php echo $href; ?>&amp;action=info');return false;" title="<?php echo $name; ?>"><?php echo $outname; ?></a></div>
	<div class="t2 <?php echo $class; ?>"><?php echo "$current_size/$torrent_size ".$size['1']; ?></div>
	<div class="t3 <?php echo $class; ?>"><?php echo $status['down']."/".$status['up']."KB/s"; ?></div>
	<div class="t4 <?php echo $class; ?>"><?php echo w3btorrent::progress_bar_html($status['percent'],100); ?></div>
	<div class="t5 <?php echo $class; ?>"><?php if (is_numeric($status['status'])) { echo etc::human_time_left($status['status']); } else { echo $status['status']; } ?></div>
	<div class="t6 <?php echo $class; ?>">
	<?php

	/* is the download a path */
	if (is_dir($status['path']))
	{
		echo "<a href=\"?page=downloads&amp;path=".base64_encode("/".basename($status['path']))."\" onclick=\"page('?page=downloads&amp;path=".base64_encode("/".basename($status['path']))."');return false;\" title=\"Go to torrent's directory\"><img src=\"pix/directory.png\" alt=\"F\"/></a>";
	}
	else
	{
		echo "<img src=\"pix/directory.d.png\" alt=\"F\" title=\"No directory yet\"/>";
	}

	/* stop */
	if ($status['pid'])
	{
 		echo " <a href=\"?page=torrent&amp;file=$href&amp;action=stop\" onclick=\"if (confirm('Are you sure you want to stop \'$name\'? ')) { page('?page=torrent&amp;file=$href&amp;action=stop'); } return false;\" title=\"Stop torrent\"><img src=\"pix/player_stop.png\" alt=\"S\"/></a> ";
	}
	else
	{
		echo " <img src=\"pix/player_stop.d.png\" alt=\"S\"/>";
	}
	
	/* quick-/start */
	if (!$status['pid'])
	{
		echo " <a href=\"?page=torrent&amp;file=$href&amp;action=start\" onclick=\"page('?page=torrent&amp;file=$href&amp;action=start');return false;\" title=\"Start torrent\"><img src=\"pix/player_play.png\" alt=\"P\"/></a>";
		echo " <a href=\"?page=torrent&amp;file=$href&amp;action=quickstart\" onclick=\"if (confirm('Are you sure you want to start \'$name\' with the last used settings?')) { page('?page=torrent&amp;file=$href&amp;action=quickstart'); } return false;\" title=\"Quick start torrent with last used setting's\"><img src=\"pix/player_fwd.png\" alt=\"Q\"/></a>";
	}
	else
	{
		echo " <img src=\"pix/player_play.d.png\" alt=\"P\" title=\"Already started\"/>";
		echo " <img src=\"pix/player_fwd.d.png\" alt=\"Q\" title=\"Already started\"/>";
	}

	/* delete */
	if (!$status['pid'])
	{
		echo " <a href=\"?page=torrent&amp;file=$href&amp;action=delete\" onclick=\"if (confirm('Are you sure you want to delete \'$name\'?')) { page('?page=torrent&amp;file=$href&amp;action=delete'); } return false;\" title=\"Delete torrent\"><img src=\"pix/delete.png\" alt=\"D\"/></a>";
	}
	else
	{
		echo " <img src=\"pix/delete.d.png\" alt=\"D\" title=\"You must stop the torrent first\"/>";
	}

	?></div>
<?php

	$total['files']++;
	$total['current_size'] 	+= $status['current_size'];
	$total['torrent_size'] 	+= $status['torrent_size'];
	$total['down']				+= $status['down'];
	$total['up']				+= $status['up']; 
	$total['percent'] 		+= $status['percent'];
	if (is_numeric($total['status']))
	{
		$total['status']		+= $status['status'];
	}	
}

$class = $w3btorrent->div_color();
/* fix byte */
$size							= explode(" ",etc::byte_change($total['torrent_size'],1));
$total['torrent_size'] 	= $size['0'];
$total['current_size'] 	= etc::byte_change($total['current_size'],1,$size['1']);

?>
<div class="t1 <?php echo $class; ?>"><img src="pix/information.png" alt=""/> <?php echo $total['files']; ?> files</div>
<div class="t2 <?php echo $class; ?>"><?php echo $total['current_size']."/".$total['torrent_size']." ".$size['1']; ?></div>
<div class="t3 <?php echo $class; ?>"><?php echo $total['down']."/".$total['up']; ?> KB/s</div>
<div class="t4 <?php echo $class; ?>"><?php echo w3btorrent::progress_bar_html(@round($total['percent']/$total['files'],0),100); ?></div>
<div class="t5 <?php echo $class; ?>"><?php echo etc::human_time_left($total['status'],"short","min"); ?></div>
<div class="t6 <?php echo $class; ?>"><a href="?page=torrent&amp;action=stop_all" onclick="if (confirm('Are you sure you want to stop all running torrents?')) { page('?page=torrent&amp;action=stop_all'); } return false;"><img style="position:relative;right:60px;" src="pix/player_stop.png" alt="" title="Stop all running torrents."/></a></div>
