<?php

/*
w3btorrent (keep it simple) - simple web fronted torrent client
Copyright (C) 2005, 2007  Vegard Hammerseth <thewulong@gmail.com> (http://thewulong.com)

This file is part of w3btorrent.

w3btorrent is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
any later version.
*/

session_name("w3btorrent");
session_start();

/* we need to check or system directory */
if (!isset($_SESSION[$_SERVER['REMOTE_ADDR']]['sysdir']))
{
	if (!isset($sysdir))
	{
		echo "You don't have any system directory set, please edit 'inc/sysdir.inc.php' to correct this.";
		exit();
	}
	elseif (!is_dir($sysdir))
	{
		echo "The system directory '$sysdir' don't exists.";
		exit();
	}
	/* check if the config is write/read-able */
	elseif (!is_writeable("$sysdir/.htconfig.xml") || !is_readable("$sysdir/.htconfig.xml"))
	{
		echo "Unable to write to '.htconfig.xml' in your selected system directory, please add write permissions. Do `chmod 666 '".realpath("$sysdir/.htconfig.xml")."'`";
		exit();
	}
	/* check if the log file is write/read-able */
	elseif (!is_writeable("$sysdir/.htlog") || !is_readable("$sysdir/.htlog"))
	{
		echo "Unable to write to '.htlog' in your selected system directory, please add write permissions. Do `chmod 666 '".realpath("$sysdir/.htlog")."'`";
		exit();
	}
	$_SESSION[$_SERVER['REMOTE_ADDR']]['sysdir'] = $sysdir;
}
unset($sysdir);


/* check if any program isin't executable */
if (isset($_SESSION[$_SERVER['REMOTE_ADDR']]['bin']))
{
	foreach ($_SESSION[$_SERVER['REMOTE_ADDR']]['bin'] as $key=>$value)
	{
		if (!is_executable($value))
		{
			unset($_SESSION[$_SERVER['REMOTE_ADDR']]['bin'][$key]);
		}
	}
}

?>
