/*
This script makes it easier doing xmlhttprequest 
Copyright (C) 2005, 2007  Vegard Hammerseth <thewulong@gmail.com> (http://wulong.name)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
function xmlhttprequest()
{
	try
	{
		x = new XMLHttpRequest();
	}
	catch (e)
	{
		try
		{
			x = new ActiveXObject('Msxml2.XMLHTTP');
		}
		catch (e)
		{
			try
			{
				x = new ActiveXObject('Microsoft.XMLHTTP');
			}
			catch (e)
			{
				x = false;
			}
	       	}
	}
	if (x)
	{
		return x;
	}
}



/* insert xml/data/info/value into a element by id */
function xml_insert(argid,argdata)
{
	if (document.getElementById(argid))
	{
		document.getElementById(argid).innerHTML = argdata;
	}
}



/* function to load page using GET supporting asynchronize and synchronize */
function http_get(argurl,argid)
{
	req = xmlhttprequest();
	req.open('GET',argurl,(argid?true:false));
	req.send(null);

	/* if we used asynchroniz query */
	if (argid)
	{
		req.onreadystatechange = function ()
		{
			if (req.readyState == '4')
			{
				xml_insert(argid,req.responseText);
			}
		}
	}
	else if (req.status == '200')
	{
		return req.responseText;
	}
}



/* function to load page using POST */
function http_post(argurl,argparameters,argid)
{
	req = xmlhttprequest();
	req.open('POST',argurl,(argid?true:false));
	req.setRequestHeader('content-type','application/x-www-form-urlencoded');
	req.setRequestHeader('connection','close');
	req.setRequestHeader('content-length',argparameters.length);
	req.send(argparameters);

	/* if we used asynchroniz query */
	if (argid)
	{
		req.onreadystatechange = function ()
		{
			if (req.readyState == '4')
			{
				xml_insert(argid,req.responseText);
			}
		}
	}
	else if (req.status == '200')
	{
		return req.responseText;
	}
}


function http_file_post(argurl,argposts_array,argfiles_array,argid)
{
	/* NOTICE!
	- argposts_array must be an array and the array-key will be the "name" (eg. <input type="text" name="THISNAME"/>)
	- argfiles_array must also be an array. Key 'name' for fieldname, key 'filename' for filename, key 'type' for content type and 'content for file content.
	*/

	/* fix post data */
	var boundarystring 	= 'w3btorrent';
	var boundary 		= '--'+boundarystring;
	var post		= boundary+'\r\n';

	/* run throgh our posts and put all post in our query */
	for (x in argposts_array)
	{
		post += 'content-disposition: form-data; name="'+x+'"\r\n\r\n';
		post += argposts_array[x]+'\r\n\r\n';
		post += boundary+'\r\n';
	}

	/* put our files in the post query */
	for (x in argfiles_array)
	{
		post += 'content-disposition: form-data; name="'+argfiles_array[x]['name']+'"; filename="'+argfiles_array[x]['filename']+'"\r\n';
		post += 'content-type: '+argfiles_array[x]['type']+'\r\n\r\n';
		post += argfiles_array[x]['content']+'\r\n';
		post += boundary+'\r\n';
	}

	
	/* http part, send query */
	req = xmlhttprequest();
	req.open('POST',argurl,(argid?true:false));
	req.setRequestHeader('content-type','multipart/form-data; boundary="'+boundarystring+'"');
	req.setRequestHeader('connection','close');
	req.setRequestHeader('content-length',post.length);
	req.send(post);

	/* if we used asynchroniz query */
	if (argid)
	{
		req.onreadystatechange = function ()
		{
			if (req.readyState == '4')
			{
				xml_insert(argid,req.responseText);
			}
		}
	}
	else if (req.status == '200')
	{
		return req.responseText;
	}
}
